package playground.samples.Avro;

import org.apache.avro.Schema;
import org.apache.avro.file.DataFileWriter;
import org.apache.avro.io.DatumWriter;
import org.apache.avro.reflect.ReflectData;
import org.apache.avro.reflect.ReflectDatumWriter;
import playground.demos.Persona;
import playground.demos.ShareClass;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;

public class GenerateData {

    public static <T> void marshal(Class<T> clazz, List<T> data, String fileName) throws IOException {
        DatumWriter<T> datumWriter = new ReflectDatumWriter<T>(clazz);
        DataFileWriter<T> dataFileWriter = new DataFileWriter<T>(datumWriter);
        Schema schema = ReflectData.get().getSchema(clazz);
        File file = new File(fileName);
        dataFileWriter.create(schema, file);
        for (T entity : data)
            dataFileWriter.append(entity);
        dataFileWriter.flush();
        dataFileWriter.close();
    }

    public static void generarShareClasses() throws IOException {
        List<ShareClass> shareClasses = Arrays.asList(
                new ShareClass("AAA", "USD", 0.31d),
                new ShareClass("BBB", "EUR", 0.40d),
                new ShareClass("CCC", "GBP", 0.56d),
                new ShareClass("DDD", "USD", 0.22d));
        marshal(ShareClass.class, shareClasses, "data/shareclass.avro");
    }

    public static void generarPersonas() throws IOException {
        List<Persona> personas = Arrays.asList(
                new Persona("Mike Wazowski", 27),
                new Persona("Jack Sparrow", 33)
        );
        marshal(Persona.class, personas, "data/personas.avro");
    }

    public static void main(String[] args) throws Exception {
        generarPersonas();

//        DatumWriter<ShareClass> datumWriter = new ReflectDatumWriter<ShareClass>(ShareClass.class);
//        DataFileWriter<ShareClass> dataFileWriter = new DataFileWriter<ShareClass>(datumWriter);
//        Schema schema = ReflectData.get().getSchema(ShareClass.class);
//        File file = new File("data/shareclass.avro");
//        dataFileWriter.create(schema, file);
//        for (ShareClass shareClass : shareClasses)
//            dataFileWriter.append(shareClass);
//        dataFileWriter.flush();
//        dataFileWriter.close();
    }
}
