package playground.samples.poblacion;

import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;

public class PoblacionPorProvincia {

    public static void main(String[] args) throws Exception {
        if (args.length != 2) {
            System.err.println("Uso: PoblacionPorProvincia <entrada> <salida>");
            System.exit(-1);
        }

        Job job = new Job();
        job.setJarByClass(PoblacionPorProvincia.class);
        job.setJobName(PoblacionPorProvincia.class.getName());

        FileInputFormat.addInputPath(job, new Path(args[0]));
        FileOutputFormat.setOutputPath(job, new Path(args[1]));

        job.setMapperClass(PoblacionPorProvinciaMapper.class);
        job.setReducerClass(PoblacionPorProvinciaReducer.class);
        job.setOutputKeyClass(Text.class);
        job.setOutputValueClass(IntWritable.class);

        job.waitForCompletion(true);
    }
}
