package playground.samples.poblacion;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;

import java.io.IOException;

public class PoblacionPorProvinciaMapper extends Mapper<LongWritable, Text, Text, IntWritable> {

    @Override
    protected void map(LongWritable key, Text value, Context context)
            throws IOException, InterruptedException {

        String line = value.toString();
        String[] fields = line.split(",");

        String rawTotal = fields[4];
        final int total = Integer.parseInt(cleanUpTotal(rawTotal));

        context.write(new Text(fields[0]), new IntWritable(total));
    }

    public String cleanUpTotal(String raw) {
        return raw.replaceAll("[^0-9]", "");
    }
}
