package es.luisbelloch.kai

import org.apache.hadoop.conf.Configuration
import java.net.URI

class FlowStep(val op: Mutator, val ptr: String,
               val junction: Pair[Int, Int],
               val io: (Class[_], Class[_]),
               val args: List[(String,String)] = List()) {

  def getArg(p: Int) = args(p)

  override def toString: String = {
    s"Fnc: ${op.getClass.getSimpleName}, Ptr: $ptr, Junction: $junction, Tag: $io, Args: $args"
  }
}

class FlowConfig(val flowName: String, val basePath: URI, val hadoopCfg: Configuration) {
  val input = basePath.resolve("input").toString
  val output = basePath.resolve("output").toString
  val errors = basePath.resolve("errors").toString
  val tmp = basePath.resolve("tmp").toString
}

class FlowResult(val succeeded: Boolean)
