package es.luisbelloch.kai

import scala.reflect.ClassTag

object Sortables {
  class SortableDataFlow[T <% Ordered[T] : Numeric](flow: DataFlow[T]) {
    def min()(implicit inTag: ClassTag[T]): DataFlow[T] = {
      Support.numericReduce(flow, (a,b) => if (a < b) a else b, inTag.runtimeClass)
    }

    def max()(implicit inTag: ClassTag[T]): DataFlow[T] = {
      Support.numericReduce(flow, (a,b) => if (a > b) a else b, inTag.runtimeClass)
    }
  }

  implicit def flowToSortableFlow[T <% Ordered[T] : Numeric](flow: DataFlow[T]) = new SortableDataFlow[T](flow)
}
