package playground.casos

import es.luisbelloch.kai.DataFlow
import java.util.Date

class Documento(val id: Int, val titulo: String, val abstr: String, val cuerpo: String)
class Termino(val id: Int, val valor: String, var puntuacion: Double)
class Contenedor(val uid: String, val peso: Int, val destino: String, val llegada: Date)

object Basico {

  def ventana(inicio: Int, elementosPorPagina: Int) =
    DataFlow[Contenedor]
      .skip(inicio)
      .take(elementosPorPagina)

  def TopNElemByGroup(topN: Int) = {
    DataFlow[Contenedor]
      .groupBy(_.destino)
      .transform[List[Contenedor]](group => {
      group._2.sortBy(_.peso).reverse.take(topN)
    })
  }
}


