package playground.casos

import es.luisbelloch.kai._
import java.util.Date

object ControladorInspeccion {
  class ControladorParaInspeccion extends Controller {
    def submit(df: DataFlow[_], cfg: FlowConfig): FlowResult = {
      df.operations zip df.typeSequence foreach(o => {
        println(s"Entrada: ${o._2._1.getName}\n" +
          s"Operacion: ${o._1.getClass.getSimpleName}, Predicado: ${o._1.reflect()}\n" +
          s"Salida: ${o._2._2.getName}\n")
      })
      return new FlowResult(true)
    }
  }

  object demo extends App {
    Kudu.controller = new ControladorParaInspeccion

    val name = "extctrl"
    val flow = DataFlow[Contenedor]
      .filter(_.destino == "VLC")
      .filter(_.peso > 500)
      .transform[Date](c => c.llegada)
      .any(_.after(new Date("2010/03/05")))

    Kudu.submit(flow, null)
  }
}
