package playground.casos

import es.luisbelloch.kai._
import es.luisbelloch.kai.FlatLand._
import java.util.regex.Pattern
import java.util.Date
import playground.demos.Persona

object Utilidades {
  val EMAIL_PATTERN: String = "^[_A-Za-z0-9-\\+]+(\\.[_A-Za-z0-9-]+)*" +
    "@[A-Za-z0-9-]+(\\.[A-Za-z0-9]+)*(\\.[A-Za-z]{2,})$"

  val pattern = Pattern.compile(EMAIL_PATTERN)

  def soloEmailsValidos(flow: DataFlow[String]): DataFlow[String] = flow
    .filter(email => {
      val m = pattern.matcher(email)
      if (m.matches()) true
      else false
    })
}

object MayoresDeEdad extends BasicApplication {
  val name = "Nombres de personas mayores de edad"
  val mayores = DataFlow[Persona]
    .filter { _.edad > 18 }
    .transform { _.nombre }

  val flow = Utilidades.soloEmailsValidos(mayores)
}

object ExaminandoDataFlow extends App {
  val flow = MayoresDeEdad.flow
  val scheduler = new BasicScheduler
  val plan = scheduler.plan(flow)
  plan map println
}