package playground.casos

import es.luisbelloch.kai._
import es.luisbelloch.kai.FlatLand._

object RankingDocumentos {

  def fancyTermFrecuencyExtractor(doc: Documento): List[Termino] = {
    val tt = doc.titulo.split(" ") map (new Termino(doc.id, _, 0.4))
    val ta = doc.abstr.split(" ") map (new Termino(doc.id, _, 0.2))
    val tb = doc.cuerpo.split(" ") map (new Termino(doc.id, _, 0.1))
    val terminosPuntuados: List[Termino] = ((tt ++ ta) ++ tb).toList
    terminosPuntuados
  }

  def normalizar(terms: List[Termino]): List[Termino] = {
    val tmax = terms.map(_.puntuacion).max
    val max = if (tmax == 0) 0.0001d else tmax
    terms.foreach { s =>
      s.puntuacion = (s.puntuacion / max)
    }
    terms
  }

  def ranking() = {
    var f = DataFlow[Documento]
      .transform(fancyTermFrecuencyExtractor)
      .flatten()
      .groupBy(_.valor)
      .transform[(String,List[Termino])](g => (g._1, normalizar(g._2)))
  }
}
