package playground.casos

import es.luisbelloch.kai._
import es.luisbelloch.kai.Sortables._
import java.util.Date
import es.luisbelloch.kai.{BasicScheduler, DataFlow}

class Temperatura {
  var ciudad: String = _
  var provincia: String = _
  var fecha: Date = _
  var max: Double = _
  var min: Double = _
  var med: Double = _

  // Indicativo;Nombre;Provincia;Altitud;Año;Mes;Dia;T.Max;Hora;T.Min;Hora;T.Med;Racha;
  // Dir;Hora;Vel.media;Prec.;Sol;Pres.máx;Hora;Pres.min;Hora
  def this(original: String) {
    this()
    val parts = original.split(";")
    ciudad = parts(1)
    provincia = parts(1)
    fecha = new Date(parts(4).toInt, parts(5).toInt, parts(6).toInt)
    max = parts(7).toDouble
    min = parts(9).toDouble
    med = parts(11).toDouble
  }

}

object TemperaturasPorProvincia extends App {

  val flow = new DataFlow[String]()
    .transform { s => new Temperatura(s) }
    .filter { t => t.provincia == "BARCELONA" }
    .transform { t => t.med }
    .max()

  val scheduler = new BasicScheduler
  scheduler.plan(flow) map println
}
