package playground.demos

import es.luisbelloch.kai.Persister

class Fund(val name: String, val country: String)

class ShareClass() {
  var name: String = _
  var currency: String = _
  var price: Double = _
  def this(name: String, currency: String, price: Double) = {
    this()
    this.name = name
    this.currency = currency
    this.price = price
  }
  override def toString(): String =
    s"Name: $name, Curr: $currency, Price: $price"
}

class ShareClassPersister
  extends Persister[ShareClass, String] {

  def save(o: ShareClass): String = {
    s"$o.name|$o.currency|$o.price"
  }

  def load(rawFlow: String): ShareClass = {
    val split = rawFlow.split("\\|")
    new ShareClass(split(0), split(1), split(2).toDouble)
  }
}