package playground.demos

import es.luisbelloch.kai._
import java.net.URI
import org.apache.hadoop.conf.Configuration

object demo1 {

  def main(args: Array[String]) {
    val input = new DataFlow[ShareClass]()
    val flow = input
      .filter { s => s.currency == "USD" }
      .filter { s => s.price > 0d }
      .filter { s => !s.name.startsWith("Z") }
      .transform { s => s.price * 2d }
      .transform { p => p.toString }
      .fold("") { (a,r) => a + "," + r }

    println("Basic")
    val basicScheduler = new BasicScheduler
    basicScheduler.plan(flow) map println

    println("\nOptimized")
    val optimizerScheduler = new OptimizedScheduler(MergeConsecutive())
    optimizerScheduler.plan(flow) map println
  }
}