package playground.demos

import es.luisbelloch.kai._
import java.util.Date

class Articulo(val sku: Int, val stock: Int)
class StockEnFecha(a: Articulo, val fecha: Date)
  extends Articulo(a.sku, a.stock)

object demo2 extends App {

  def inspect(plan: List[FlowStep]) {
    plan map(s => {
      println(s"F: ${s.op.getClass.getSimpleName}(${s.ptr.replace("playground.","")}), " +
        s"IO: (${s.junction._1}, ${s.io._1.getSimpleName}) to " +
        s"(${s.junction._2}, ${s.io._2.getSimpleName})")
    })
  }

  val flow = DataFlow[Articulo]
    .transform[StockEnFecha](a => new StockEnFecha(a, new Date()))
    .transform[Int](s => s.sku)
    .transform[String](s => s"ES-$s")

  // val scheduler: Scheduler = new BasicScheduler
  val scheduler: Scheduler = new OptimizedScheduler(MergeConsecutive())
  val plan = scheduler.plan(flow)
  inspect(plan)
}
