package playground.demos

import es.luisbelloch.kai._
import java.util.Date
import scala.beans.BeanProperty

class Persona {
  @BeanProperty var nombre: String = _
  @BeanProperty var edad: Int = _
  def this(nombre: String, edad: Int) {
    this()
    this.nombre = nombre
    this.edad = edad
  }
  override def toString(): String = s"nombre: $nombre, edad: $edad"
}

class Temperature(val date: Date, val value: Double)

class demo4 extends BasicApplication {
  val name: String = "demo4"

  val flow = new DataFlow[Persona]
    .skip(3)
    .contains(new Persona("Jack Sparrow", 20))
}

object demoFlatten extends App {
  import es.luisbelloch.kai.FlatLand._
  var flow = DataFlow[Persona]
    .groupBy(_.nombre)
    .transform(_._2)
    .flatten()

  flow.operations zip flow.typeSequence map println
}

object demo4_pg {
  val f = (new demo4).flow
  def main(args: Array[String]) {
    f.operations zip f.typeSequence map println
  }
}