package es.luisbelloch.kai

import org.scalatest._
import org.apache.hadoop.mrunit.mapreduce.MapDriver
import org.apache.hadoop.io.{ LongWritable, NullWritable, Text }
import org.scalatest.junit.JUnitRunner
import org.junit.runner.RunWith

import es.luisbelloch.kai._
import playground.demos.ShareClass

object TestImplicits {
  implicit def longToWritable(l: Long) = new LongWritable(l)
  implicit def stringToText(s: String) = new Text(s)
  implicit def lambdaToString[A,B](f: A => B): String = f.getClass.getName
}
import TestImplicits._

object SampleFilters {
  val alwaysFalse = new DataFlow[ShareClass]() filter { s => false }
  val filter0 = new DataFlow[ShareClass]() filter { s => s.currency == "USD" }
}

@RunWith(classOf[JUnitRunner])
class FilterMapperTest extends FlatSpec with OneInstancePerTest {

//  val driver = new MapDriver[LongWritable, Text, NullWritable, Text]
//  driver.withMapper(new FilterMapper)
//
//  "FilterMapper" should "filter rows properly" in {
//    val filterName = SampleFilters.filter0.operations.head.reflect()
//    driver.getConfiguration.set(FilterMapper.FILTER_FNC_PTR, filterName)
//    driver.withInput(1L, "AAA|USD|0.45")
//          .withInput(2L, "|GBP|1.34")
//          .withInput(2L, "BBB|EUR|0.32")
//          .withOutput(NullWritable.get(), "AAA|USD|0.45")
//          .runTest()
//  }
//
//  it should "return empty data set when filter is too aggressive" in {
//    val filterName = SampleFilters.alwaysFalse.operations.head.reflect()
//    driver.getConfiguration.set(FilterMapper.FILTER_FNC_PTR, filterName)
//    driver.withInput(1L, "AAA|USD|0.45")
//          .withInput(2L, "BBB|EUR|0.32")
//          .withInput(3L, "CCC|EUR|2.83")
//          .runTest()
//  }
}
