package es.luisbelloch.kai

import org.junit.runner.RunWith
import org.scalatest.junit.JUnitRunner
import org.scalatest.{OneInstancePerTest, FlatSpec}
import org.scalatest.mock.MockitoSugar.mock
import org.mockito.Mockito._
import org.mockito.Matchers._

@RunWith(classOf[JUnitRunner])
class OptimizerSpec extends FlatSpec with OneInstancePerTest {

//  "OptimizedScheduler" should "apply all optimizers in pipeline in given order" in {
//    val o1 = mock[Optimizer]
//    val o2 = mock[Optimizer]
//
//    val flow = new DataFlow[Int].filter(i => i > 4)
//    val flowSteps = new BasicScheduler().plan(flow)
//    val scheduler = new OptimizedScheduler(o1, o2)
//
//    when(o1.solve(flowSteps)).thenReturn(flowSteps)
//    when(o2.solve(flowSteps)).thenReturn(flowSteps)
//
//    scheduler.plan(flow)
//    verify(o1, times(1)).solve(flowSteps)
//    verify(o2, times(1)).solve(flowSteps)
//  }

  behavior of "MergeConsecutive"

  it should "combine two subsequent Filter operations" in {
    val flow = new DataFlow[Int]
      .filter(i => i > 4)
      .filter(i => i < 5)

    val scheduler = new OptimizedScheduler(MergeConsecutive())

    expectResult(1) { scheduler.plan(flow).length }
  }

}
